// spica javascript libraries - element.js
// == written by Takuya Otani <takuya.otani@gmail.com> ===
// == Copyright (C) 2006 SimpleBoxes/SerendipityNZ Ltd. ==

// [guideline]
// -- http://serennz.sakura.ne.jp/guidelines/js_en_000.txt
// -- http://serennz.sakura.ne.jp/guidelines/js_ja_000.txt

Spica.getElementsByClassName = function(name,target)
{
	var result = [];
	var object  = null;
	var search = new RegExp('(^|\\s)' + name + '(\\s|$)');
	if (target && target.getElementsByTagName)
		object = target.getElementsByTagName('*');
	if (!object)
		object = document.getElementsByTagName ? document.getElementsByTagName('*') : document.all;
	for (var i=0,n=object.length;i<n;i++)
	{
		var check = object[i].getAttribute('class') || object[i].className;
		if (check.match(search)) result.push(object[i]);
	}
	return result;
}
Spica.$ = function(element)
{
	if (arguments.length > 1)
	{
		var elements = new Array();
		for (var i=0,n=arguments.length;i<n;i++)
			elements.push($(arguments[i]));
		return elements;
	}
	if (typeof element == 'string')
		return document.getElementById(element);
	return null;
}
Spica.DOM = {
	getOffsetX : function(obj)
	{
		if (!obj) return 0;
		var x = obj.offsetLeft;
		var parent = obj.offsetParent;
		while (parent)
		{
			x += parent.offsetLeft;
			parent = parent.offsetParent;
		}
		return x;
	},
	getOffsetY : function(obj)
	{
		if (!obj) return 0;
		var y = obj.offsetTop;
		var parent = obj.offsetParent;
		while (parent)
		{
			y += parent.offsetTop;
			parent = parent.offsetParent;
		}
		return y;
	},
	getWidth : function(obj)
	{
		if (!obj) return 0;
		return obj.clientWidth || obj.offsetWidth;
	},
	getHeight : function(obj)
	{
		if (!obj) return 0;
		return obj.clientHeight || obj.offsetHeight;
	},
	getParent : function(obj)
	{
		if (!obj) return null;
		return obj.parentNode || obj.parentElement;
	},
	insertBefore : function(newNode, existingNode)
	{
		var parent = Spica.DOM.getParent(existingNode);
		if (!parent) return;
		parent.insertBefore(newNode, existingNode);
	},
	insertAfter : function(newNode, existingNode)
	{
		var parent = Spica.DOM.getParent(existingNode);
		if (!parent) return;
		if (existingNode.nextSibling)
			parent.insertBefore(newNode, existingNode.nextSibling);
		else
			parent.appendChild(newNode);
	}
};
